angular.module('RcWareApiModule', ['ng']).
    factory('RcWareApi', function($http, AuthService, $q, $log, ConfigService) {
    
    function Api(){
    };
    
    var api = new Api();
    
    var config = {};
    var cache = {};
    
    Api.prototype.clearCache = function(){
      cache = {allDevices:{data:[]}};
    };
    
    Api.prototype.$isLoading = false; //GUI helper

    Api.prototype.addCredentials = function(data){ //fixme - use interceptor
      RcWareExtend(data, {"Credentials":
                        {   "User":AuthService.$credentials.Username,
                            "Password":AuthService.$credentials.Password
                        }
               });
               
      return data;
    };

    Api.prototype.serializeToQueryFormat = function(obj, prefix) {
        var str = [];
        for(var p in obj) {
            var k = prefix ? prefix + "[" + p + "]" : p, v = obj[p];
            var toPush = "";
            if(typeof v == "object" && v != null){
              toPush = this.serializeToQueryFormat(v, k);
            }
            else if(v == null) {
              toPush = encodeURIComponent(k) + "=";
            }
            else {
              toPush = encodeURIComponent(k) + "=" + encodeURIComponent(v);
            }

            str.push(toPush);
        }
        return str.join("&");
    }
    


    // Api.prototype.deleteObjectOfType = function(typeInfo, item){
    
    //   var deferred = $q.defer();
    //   var promise = deferred.promise;
    
      
      
    //   promise.success = function(fn) {
    //     promise.then(function(data) {
    //       fn(data/*, response.status, response.headers, config*/);
    //     });
    //     return promise;
    //   };

    //   promise.error = function(fn) {
    //     promise.then(null, function(data) {
    //       fn(data/*, response.status, response.headers, config*/);
    //     });
    //     return promise;
    //   };

          
    //   //fixme - implement proper api call
    //   if(!AuthService.$isAuthenticated){
    //     AuthService.logout();
    //   }


    //     this.getAllObjectsOfType(typeInfo).success(function(data){
    //       for(var i in cache[typeInfo.Name]){
    //         if(cache[typeInfo.Name][i][typeInfo.Config.Id] == item[typeInfo.Config.Id]){
    //           cache[typeInfo.Name].splice(i,1);
    //         }
    //       }

    //       deferred.resolve();

          
    //     }).error(function(){
    //       deferred.reject();
    //       alert("Data cannot be loaded.");//fixme - add error box
    //     });


      
          

    //     return promise;
    // };
    

    Api.prototype.updateObjectOfType = function(typeInfo, item){
    
      var deferred = $q.defer();
      var promise = deferred.promise;
    
      
      
      promise.success = function(fn) {
        promise.then(function(data) {
          fn(data/*, response.status, response.headers, config*/);
        });
        return promise;
      };

      promise.error = function(fn) {
        promise.then(null, function(data) {
          fn(data/*, response.status, response.headers, config*/);
        });
        return promise;
      };

          
      //fixme - implement proper api call
      if(!AuthService.$isAuthenticated){
        AuthService.logout();
      }

        var d = {msg:this.addCredentials({})};
        d.msg[typeInfo.Config.ApiName] = item;

        if(ConfigService.PostFormat == "FormData"){//uPLC compatible format
          d = this.serializeToQueryFormat(d);
        }

        var http = $http.post(ConfigService.ApiPrefix+'Update'+typeInfo.Config.ApiName, d).success(function(data){
            

            if(data.Error.Code=="0;OK"){
              delete cache[typeInfo.Name];
              deferred.resolve();
            }
            else {
              deferred.reject(data);
            }
          }).error(function(data, status){
             //$log.log(data);
             deferred.reject(data);
          });

        return promise;
    }
  
    
    Api.prototype.getAllObjectsOfType = function(typeInfo, forceRefresh){
    
      var deferred = $q.defer();
      var promise = deferred.promise;

      if(forceRefresh === true){ //this should be enough to enforce the refresh
        delete cache[typeInfo.Name];
      }
    
      if(typeof forceRefresh == "undefined"){
        forceRefresh = false;
      }
      
      promise.success = function(fn) {
        promise.then(function(data) {
          fn(data/*, response.status, response.headers, config*/);
        });
        return promise;
      };

      promise.error = function(fn) {
        promise.then(null, function(data) {
          fn(data/*, response.status, response.headers, config*/);
        });
        return promise;
      };

          
      //fixme - implement proper api call
      if(!AuthService.$isAuthenticated){
        AuthService.logout();
      }


      if(typeInfo.Config.CacheEnabled && typeof cache[typeInfo.Name] != "undefined" && forceRefresh == false){
        deferred.resolve(cache[typeInfo.Name]);
      }
      else {

        var d = {msg:this.addCredentials({})}; //data to be sent


        if(ConfigService.PostFormat == "FormData"){ //uPLC compatible format
          d = this.serializeToQueryFormat(d);
        }

  		  api.$isLoading = true;
  		  var http = $http.post(ConfigService.ApiPrefix+'GetAll'+typeInfo.Config.ApiPlural, d).success(function(data){
            

            if(data.Error.Code=="0;OK"){
              cache[typeInfo.Name] = data[typeInfo.Config.ApiPlural];
              deferred.resolve(cache[typeInfo.Name]);
            }
            else {
              deferred.reject(data);
            }

            api.$isLoading = false;
          }).error(function(data, status){
  			     //$log.log(data);
             deferred.reject(data);
             api.$isLoading = false;
          });
      }
	  
	  
	
          

        return promise;
    };
    
    
    // Api.prototype.deleteUser = function(user){
    
    //   var deferred = $q.defer();
    //   var promise = deferred.promise;
    
      
      
    //   promise.success = function(fn) {
    //     promise.then(function(data) {
    //       fn(data/*, response.status, response.headers, config*/);
    //     });
    //     return promise;
    //   };

    //   promise.error = function(fn) {
    //     promise.then(null, function(data) {
    //       fn(data/*, response.status, response.headers, config*/);
    //     });
    //     return promise;
    //   };
      
      
    //     var http = $http.post('/api/json/removeuser', this.addCredentials({user:[user.Name]})).success(function(data){
    //       deferred.resolve(data);
    //     }).error(function(data){
    //       if(typeof data["exception-name"] != "undefined" && data["exception-name"] == "UnauthorizedAccessException"){
    //         AuthService.logout();
    //       }
    //       deferred.reject(data);
    //     });

        
    //     return promise;
    // };
    
    
    Api.prototype.addObjectOfType = function(typeInfo, item){
    
      var deferred = $q.defer();
      var promise = deferred.promise;
    
      
      
      promise.success = function(fn) {
        promise.then(function(data) {
          fn(data/*, response.status, response.headers, config*/);
        });
        return promise;
      };

      promise.error = function(fn) {
        promise.then(null, function(data) {
          fn(data/*, response.status, response.headers, config*/);
        });
        return promise;
      };

          
      //fixme - implement proper api call
      if(!AuthService.$isAuthenticated){
        AuthService.logout();
      }

        var d = {msg:this.addCredentials({})};
        d.msg[typeInfo.Config.ApiName] = item;

        if(ConfigService.PostFormat == "FormData"){
          d = this.serializeToQueryFormat(d);
        }

        var http = $http.post(ConfigService.ApiPrefix+'Add'+typeInfo.Config.ApiName, d).success(function(data){
            

            if(data.Error.Code=="0;OK"){
              delete cache[typeInfo.Name];
              deferred.resolve();
            }
            else {
              deferred.reject(data);
            }
          }).error(function(data, status){
             //$log.log(data);
             deferred.reject(data);
          });

        return promise;
    };
    
    
    // Api.prototype.updateUser = function(newUser){
    
    //   var deferred = $q.defer();
    //   var promise = deferred.promise;
    
      
      
    //   promise.success = function(fn) {
    //     promise.then(function(data) {
    //       fn(data/*, response.status, response.headers, config*/);
    //     });
    //     return promise;
    //   };

    //   promise.error = function(fn) {
    //     promise.then(null, function(data) {
    //       fn(data/*, response.status, response.headers, config*/);
    //     });
    //     return promise;
    //   };
      
      
    //     var http = $http.post('/api/json/updateuser', this.addCredentials({user:newUser})).success(function(data){
    //       deferred.resolve(data);
    //     }).error(function(data){
    //       if(typeof data["exception-name"] != "undefined" && data["exception-name"] == "UnauthorizedAccessException"){
    //         AuthService.logout();
    //       }
    //       deferred.reject(data);
    //     });

        
    //     return promise;
    // };
    
    
    
    
    
    
    
    
    
    
    
    //check credentials
    Api.prototype.checkCredentials = function(username, password){
    
      var deferred = $q.defer();
      var promise = deferred.promise;
    
      
      
      promise.success = function(fn) {
        promise.then(function(data) {
          fn(data/*, response.status, response.headers, config*/);
        });
        return promise;
      };

      promise.error = function(fn) {
        promise.then(null, function(data) {
          fn(data/*, response.status, response.headers, config*/);
        });
        return promise;
      };

        var d = {msg:{Credentials:{User:username, Password:password}}};

        if(ConfigService.PostFormat == "FormData"){ //uPLC compatible format
          d = this.serializeToQueryFormat(d);
        }
    
        var http = $http.post(ConfigService.ApiPrefix+'CheckCredentials', d).success(function(data){
          if(data.Error.Code=="0;OK"){
            
      			AuthService.$credentials.Username = username;
      			AuthService.$credentials.Password = password;
      			AuthService.$isAuthenticated = true;
            deferred.resolve(data);
          }
          else {
            deferred.reject(data);
          }
          
        }).error(function(data){
          deferred.reject(data);
        });


        
        return promise;
    };
    
  
    //fixme: use it in controller  
    // Api.prototype.getVariableById = function(id){
      

    // }

    
    // Api.prototype.getAllVariables = function(forceRefresh){
    
    //   var deferred = $q.defer();
    //   var promise = deferred.promise;
    
      
      
    //   promise.success = function(fn) {
    //     promise.then(function(data) {
    //       fn(data/*, response.status, response.headers, config*/);
    //     });
    //     return promise;
    //   };

    //   promise.error = function(fn) {
    //     promise.then(null, function(data) {
    //       fn(data/*, response.status, response.headers, config*/);
    //     });
    //     return promise;
    //   };

    //   //fixme - implement API call
    //   if(!AuthService.$isAuthenticated){
    //     AuthService.logout();
    //   }
    //   deferred.resolve([ new RcWareDbVariable([  new RcWareDbKeyValuePair("První","1"),
    //                                                         new RcWareDbKeyValuePair("Druhá","2")], "prvníId"),
    //                                 new RcWareDbVariable([  new RcWareDbKeyValuePair("Třetí","3"),
    //                                                         new RcWareDbKeyValuePair("Čtvrtá","4")], "druhéId"),
    //                                 new RcWareDbVariable([  new RcWareDbKeyValuePair("Pátá","5"),
    //                                                         new RcWareDbKeyValuePair("Šestá","6"),
    //                                                         new RcWareDbKeyValuePair("_innerId","6666666Id")])

    //                                                        ]);

                            

    //   //fixme - force refresh
        
    //     return promise;
    // };
    
    
    
    
    
    
    
    
    
    return api;
    });