angular.module('RcWareAdminGenerator', ["services", "RcWareApiModule" ]).
  config(function($routeProvider) {
    $routeProvider.
      when('/login', {controller:LoginCtrl, templateUrl:'loginTemplate.html'}).
      when('/logout', {controller:LogoutCtrl, templateUrl:'loginTemplate.html'}).
      when('/start', {controller:StartCtrl, templateUrl:'startTemplate.html'}).
      when('/editProperty', {controller:EditPropertyCtrl, templateUrl:'editPropertyTemplate.html'}).
      when('/showAll/:typeName', {controller:ShowAllCtrl, templateUrl:'showAllTemplate.html'}).
      when('/edit/:typeName/:id', {controller:EditCtrl, templateUrl:'editTemplate.html'}).
      when('/add/:typeName', {controller:AddCtrl, templateUrl:'editTemplate.html'}).
      otherwise({redirectTo:'/start'}); //fixme - add authentication
  }).
  directive('rcwareInput', function factory($compile, EditService, $location, ConfigService, $log) {
  var directiveDefinitionObject = {
    replace: true,
    restrict: 'E',
    scope: {
      itemProperty: '=rcwareModel',
      placeholder: '=rcwarePlaceholder',
      type: '=rcwareType',
      disabled: '=rcwareDisabled',
      propertyName: '=rcwarePropertyName',
      propertyConfig: '=rcwarePropertyConfig'
    },

    //we have to do here some magic with template generating because of: https://github.com/angular/angular.js/issues/1332
    link: function link(scope, element, attrs, transclude) {
            var template = '';

            //known arrays are handled separately
            if(scope.propertyConfig.DataType.toLowerCase().indexOf("arrayof") > -1){
              template += '<div><a ng-click="editProperty()" href="" class="btn btn-primary">Edit {{propertyName}}</a><br />{{itemProperty}}</div>';
            }
            else {

              template += '<input type="';
              template += scope.type;
              template +='" ng-model="itemProperty" placeholder="{{placeholder}}" ng-disabled="disabled">';
            }
            element.append( $compile(template)(scope) ); 
                
      return  function preLink($scope, iElement, iAttrs, controller) {  }
  },

  controller: function ($scope){
    $scope.editProperty = function(){
      EditService.ItemProperty = $scope.itemProperty;
      EditService.TypeInfo = ConfigService.TypeInfos[$scope.propertyConfig.DataType.substring(7)]; //fixme:better string handling
      EditService.ReturnPath = $location.path();
      EditService.PropertyName = $scope.propertyName;
      $location.path("/editProperty");
      //alert("edit!" + EditService.ReturnPath);
    }
  }


  };
  return directiveDefinitionObject;
});
 


function EditPropertyCtrl($scope, AuthService, $routeParams, RcWareApi, $location, ConfigService, EditService, $log){

  $scope.item = EditService.Item;
  $scope.propertyName = EditService.PropertyName;
  $scope.returnPath = EditService.ReturnPath;
  $scope.typeInfo = EditService.TypeInfo;

  $scope.saveProperty = function(){
    $location.path($scope.returnPath).search("fromEditService","true");
  }
                    
}


function AddCtrl($scope, AuthService, $routeParams, RcWareApi, $location, ConfigService, EditService){

  
  $scope.typeInfo = ConfigService.TypeInfos[$routeParams.typeName];
  $scope.operation = "Add"; //to enabled Add/Edit shared template

  $scope.item = eval("new " + $routeParams.typeName + "()"); //fixme: no eval!

 
  
  
  $scope.saveItem = function(){
    RcWareApi.addObjectOfType($scope.typeInfo,$scope.item).success(function(){
      $location.path("/showAll/"+$scope.typeInfo.Name);
    }).
    error(function(data){
        alert("Cannot save data");
    });
  
  };
  
};




function EditCtrl($scope, AuthService, $routeParams, RcWareApi, $location, ConfigService, EditService){
  $scope.item = {};
  $scope.operation = "Edit"; //to enabled Add/Edit shared template
  
  $scope.typeInfo = ConfigService.TypeInfos[$routeParams.typeName];

  if(typeof $location.search()["fromEditService"] != "undefined"
      && $location.search()["fromEditService"] == "true"
      && typeof EditService.Item != "undefined"
      && $routeParams.id == EditService.Item[$scope.typeInfo.Config.Id]
       ){
    $scope.item = EditService.Item;
  }
  else {
  



    RcWareApi.getAllObjectsOfType($scope.typeInfo).success(function(data){
      angular.forEach(data, function(value){ //fetch all objects and find the selected item
          if(value[$scope.typeInfo.Config.Id] == $routeParams.id){
            angular.copy(value, $scope.item);
            EditService.Item = $scope.item;
          }
        });
    }).error(function(){
      $scope.errors.push("Data cannot be loaded.");//fixme - add error box
    });
  }

  
  
  
  $scope.saveItem = function(){
    RcWareApi.updateObjectOfType($scope.typeInfo,$scope.item).success(function(){
      $location.path("/showAll/"+$scope.typeInfo.Name);
    }).
    error(function(data){
      if(typeof data["exception-name"] != "undefined"){
        alert(data.message);
      }
      else {
        alert("Cannot save data");
      }
    });
  
  };
  
  // $scope.deleteItem = function(){
  //   if (confirm("Are you sure?")) {
      
  //     RcWareApi.deleteObjectOfType($scope.typeInfo,$scope.item).success(function(){
  //         $location.path("/showAll/"+$scope.typeInfo.Name);
  //       }).
  //       error(function(){
  //         alert("Cannot delete "+$scope.item);
  //       });
  //   }
  // }
                    
}



function LoginCtrl($scope, AuthService, $location, $log, RcWareApi, ConfigService){

  $scope.Username = "";
  $scope.Password = "";

  
  $scope.login = function(){
    RcWareApi.checkCredentials($scope.Username, $scope.Password).success(function(){
      $location.path("/start");
    }).
    error(function(){
      alert("Invalid credentials");
    });
    
  }
}


function LogoutCtrl($scope, AuthService, $location){

  AuthService.logout();
  
  $location.path("/login");
  
}



function StartCtrl($scope, AuthService, $location, ConfigService){

  var first = null;
  angular.forEach(ConfigService.Types, function(value, typeName){
    if(first == null){
      first = typeName;
    }
  });

  $location.path("/showAll/"+first);  //use the first typeName we get
  
  
  
}



function ShowAllCtrl($scope, AuthService, $routeParams, $location, RcWareApi, $filter, ConfigService, $log){

  $scope.fullData = [];
  $scope.filteredData = [];
  $scope.limit = ConfigService.DefaultPagingLimit;
  $scope.offset = 0;
  $scope.objectListFiltered = [];
  $scope.Api = RcWareApi; //Api.$isLoading message...


   //manually create list of properties - fixme: add config options
  $scope.typeInfo = ConfigService.TypeInfos[$routeParams.typeName];
  ConfigService.CurrentView = $routeParams.typeName;



  RcWareApi.getAllObjectsOfType($scope.typeInfo).success(function(data){
    $scope.fullData = data;
  }).error(function(){
    $log.log("Data cannot be loaded.");//fixme - add error box
  });


  $scope.$watch("search", function(_new, _old){
    if(_new != _old){
      $scope.offset = 0;
      filterAndTrim($scope.fullData, _new, $scope.limit, $scope.offset);
    }
  });
  
  $scope.$watch("fullData", function(_new, _old){//we rely on the fact, that it is called at least once
      $scope.offset = 0;
      filterAndTrim(_new, $scope.search,$scope.limit, $scope.offset);
  });
  
  
  $scope.$watch("offset", function(_new, _old){
    if(_new != _old){
      filterAndTrim($scope.fullData, $scope.search,$scope.limit, _new);
    }
  });
  
  //helper - filter, sort, apply limit
  function filterAndTrim(data,search, limit, offset){ //fixme orderby
    if(typeof search == "undefined" || search == "" ){//speed optimization - skip useles loops
      $scope.filteredData = data;
    }
    else {
      //custom filter can be implemented here
      $scope.filteredData = $filter("filter")(data, $scope.search);
    }
    
    $scope.objectListFiltered = $scope.filteredData.slice(offset, offset+limit);

  };

    $scope.next = function (){
    if($scope.offset+$scope.limit < $scope.filteredData.length )
      {
        $scope.offset = $scope.offset+$scope.limit;
      }
    }
    
    $scope.prev = function (){
      $scope.offset = Math.max($scope.offset-$scope.limit, 0);
    }
    
    $scope.refreshItems = function (){
        RcWareApi.getAllObjectsOfType($scope.typeInfo, true).success(function(data){
          $scope.fullData = data;
        }).error(function(){
          $log.log("Data cannot be loaded.");//fixme - add error box
        });
    }
    
    $scope.showStartIndex = function(){
      return Math.min($scope.objectListFiltered.length == 0) ? 0 : $scope.offset+1;
    }

    $scope.isPaged = function() {
      return $scope.limit < $scope.filteredData.length;
    }

    $scope.navColspan = function(){
      return Math.max(1,$scope.typeInfo.enabledListProperties().length - 1)
    }

    $scope.actionColspan = function(){
      return ($scope.typeInfo.enabledListProperties().length < 2) ? 2 : 1;
    }
  
}


var RcWareTypeInfo = function(name, properties, cfg){
  this.Name = name;
  this.Properties = properties;

  this.Config = {
    Name: name,
    ApiName: name,
    CacheEnabled: true,
    RefreshEnabled: false,
    Show: true,
    EditEnabled: true,
    AddEnabled: false, 
    RefreshEnabled: true,
    Order: 0,
    Id: "Id",
    Properties: {}
  }

  if(typeof name == "undefined" || typeof cfg == "undefined"){
    return; //fixme - more checks?
  }

  this.Config = RcWareExtend(this.Config, cfg.Types[name]);



  //plural handling
  if(typeof cfg.Types[name]["NamePlural"] == "undefined"){
    this.Config.NamePlural = this.Config.Name + "s";
  }//else is not necessary

  //plural handling
  if(typeof cfg.Types[name]["ApiPlural"] == "undefined"){
    this.Config.ApiPlural = this.Config.ApiName + "s";
  }//else is not necessary

  //properties overriden
  if(typeof cfg.Types[name]["Properties"] != "undefined"){
    var foo = [];
    angular.forEach(cfg.Types[name]["Properties"], function(item, propertyName){
      foo.push([propertyName, item]);
    });
    foo.sort(function(a,b){

      if(typeof a[1].Order != "undefined" && b[1].Order != "undefined"){
        return a[1].Order - b[1].Order;  
      }
      else {
        return 0;
      }
    });

    //now we override the default Properties
    this.Properties = [];

    angular.forEach(foo, function(item){
      this.Properties.push(item[0]);
    }, this);
  }

  //end of the loop - generate the Config.Properties and merege it with user cfg
  var bar = {};
  angular.forEach(this.Properties, function(propertyName){
    //default property properties
    bar[propertyName] = {
      Order: 0,
      InputType: (propertyName == "Password") ? "password" : "text",
      EditEnabled: !(propertyName == this.Config.Id),
      ShowInList: true,
      ShowInEdit: true,
      DataType: "string"
    }
  }, this);

  this.Config.Properties = RcWareExtend(bar, cfg.Types[name]["Properties"]); //angular.extend does not do deep copy

}

RcWareTypeInfo.prototype.enabledListProperties = function(){
  var out = [];
  angular.forEach(this.Properties, function(value){
    if(this.Config.Properties[value].ShowInList){
      out.push(value);
    }
  }, this);

  return out;
}

RcWareTypeInfo.prototype.enabledEditProperties = function(){
  var out = [];
  angular.forEach(this.Properties, function(value){
    if(this.Config.Properties[value].ShowInEdit){
      out.push(value);
    }
  }, this);

  return out;
}

/*Helper function until we can use jQuery.extend or angular.extend is fixed*/
RcWareExtend = function(dst, src){

  angular.forEach(src, function(value,key){
    if(angular.isObject(value) && !angular.isArray(value)){
      if(!angular.isObject(dst[key])){ //property does not exist yet or is not an objectc
        dst[key] = {};  
      }
      RcWareExtend(dst[key], src[key]);
    }
    else {
      dst[key] = value;
    }
  }, this);


  return dst;
}

