//this is a helper module - services
angular.module('services',[]).
  factory('EditService', function($log) {
    //this is just a plain holder for object passing in "edit" controllers
      var service = {};
      

      return service;
    }).
  
    factory('AuthService', function($log, $location,$rootScope, ConfigService) {
      var credentials = {Username:"", Password:""}; 

      var authService = {};
      authService.$credentials = credentials;
      authService.$isAuthenticated = false;
      if(ConfigService.CheckCredentials == false){
        authService.$isAuthenticated = true;
        authService.$credentials.Username = ConfigService.Username;
        authService.$credentials.Password = ConfigService.Password;
      }
      authService.logout = function(){
        authService.$credentials.Username = "";  
        authService.$credentials.Password = "";
        authService.$isAuthenticated = false;
        $location.path("/login");
       };
       
       $rootScope.AuthService = authService; //enables log out button binding...

      return authService;
    }).


    factory('ConfigService', function($log, $location,$rootScope) {
       

      var AppConfig = function(cfg){
        this.CurrentView = "";
        this.AppTitle = "RcWare Administration";
        this.CheckCredentials = true;
        this.LogOutEnabled = true;
        this.Username = null;
        this.Password = null;
        this.ApiPrefix = "/admin/json/";
        this.Types = {};
        this.DefaultPagingLimit = 50;
        RcWareExtend(this, cfg);



        this.TypeInfos = {};
        angular.forEach(this.Types, function(value, typeName){
          var type = eval("new "+typeName+"()");
          var typeProperties = [];

       
          angular.forEach(type, function(value, key){
            typeProperties.push(key);
          }, this); //warning - note "this" - context

          this.TypeInfos[typeName] = new RcWareTypeInfo(typeName, typeProperties, cfg);

        }, this); //warning - note "this" - context
      };

      AppConfig.prototype.enabledTypeInfos = function(){
        var out = [];
        angular.forEach(this.TypeInfos, function(value, typeName){
          if(value.Config.Show){
            out.push(value);
          }

        });

        out.sort(function(a,b){return a.Order - b.Order}); //to make life easier in templates

        return out;
      }
       
      $rootScope.ConfigService = new AppConfig(userAppConfig);
      return $rootScope.ConfigService; //global config!
    });