﻿///#source 1 1 /js/dictionary.js
angular.module('Dictionary', []).
   service('Dictionary', function () {
       var out = {
           "cs": {
               "": { //some metadata
                   "domain": "messages",
                   "lang": "cs",
                   "plural_forms": "nplurals=3; plural=n==0 ? 2 : n==1 ? 0 : n<5 ? 1 : 2;",
                   "datetime_formats": {
                       "month": ["leden", "únor", "březen", "duben", "květen", "červen", "červenec", "srpen", "září", "říjen", "listopad", "prosinec"],
                       "monthInflection": ["ledna", "února", "března", "dubna", "května", "června", "července", "srpna", "září", "října", "listopadu", "prosince"],
                       "shortmonth": ["1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12"],
                       "day": { 0: "neděle", 1: "pondělí", 2: "úterý", 3: "středa", 4: "čtvrtek", 5: "pátek", 6: "sobota" },
                       "shortday": ["ne", "po", "út", "st", "čt", "pá", "so"],
                       "ampms": ["dop.", "odp."],
                       "medium": "d.M.yyyy H:mm:ss",
                       "short": "d.M.yy H:mm",
                       "fullDate": "EEEE, d. MMMM y",
                       "longDate": "d. MMMM y",
                       "mediumDate": "d.M.yyyy",
                       "shortDate": "d.M.yy",
                       "mediumTime": "H:mm:ss",
                       "shortTime": "H:mm",
                       "timeSeparator": ".",
                       "dateSeparator": ".",
                       "decimalPoint": ",",
                       "groupSeparator": " "
                   }
               },
               //strings
               "dog": [null, "%d pes", "%d psi", "%d psů"],
               "monday": [null, "pondělí"],
               "tuesday": [null, "úterý"],
               "wednesday": [null, "středa"],
               "thursday": [null, "čtvrtek"],
               "friday": [null, "pátek"],
               "saturday": [null, "sobota"],
               "sunday": [null, "neděle"],
               "january": [null, "leden"],
               "february": [null, "únor"],
               "march": [null, "březen"],
               "april": [null, "duben"],
               "may": [null, "květen"],
               "june": [null, "červen"],
               "july": [null, "červenec"],
               "august": [null, "srpen"],
               "september": [null, "září"],
               "october": [null, "říjen"],
               "november": [null, "listopad"],
               "december": [null, "prosinec"]
           },
           "en": {
               "": { //some metadata
                   "domain": "messages",
                   "lang": "en",
                   "plural-forms": "nplurals=2; plural=(n != 1);",
                   "datetime_formats": {
                       "month": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
                       "shortmonth": ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
                       "day": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
                       "shortday": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
                       "ampms": ["AM", "PM"],
                       "medium": "MMM d, y h:mm:ss a",
                       "short": "M/d/yy h:mm a",
                       "fullDate": "EEEE, MMMM d, y",
                       "longDate": "MMMM d, y",
                       "mediumDate": "MMM d, y",
                       "shortDate": "M/d/yy",
                       "mediumTime": "h:mm:ss a",
                       "shortTime": "h:mm a",
                       "timeSeparator": ":",
                       "dateSeparator": "/",
                       "decimalPoint": ".",
                       "groupSeparator": ","
                   }

               },
               //strings
               "pes": [null, "%d dog", "%d dogs"]
           },
           "de": {
               "": { //some metadata
                   "domain": "messages",
                   "lang": "de",
                   "plural_forms": "nplurals=3; plural=n==0 ? 2 : n==1 ? 0 : n<5 ? 1 : 2;",
                   "datetime_formats": {
                       "month": ["Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"],
                       "shortmonth": ["Jan", "Feb", "Mär", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dez"],
                       "day": ["Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"],
                       "shortday": ["So.", "Mo.", "Di.", "Mi.", "Do.", "Fr.", "Sa."],
                       "ampms": ["vorm.", "nachm."],
                       "medium": "dd.MM.yyyy HH:mm:ss",
                       "short": "dd.MM.yy HH:mm",
                       "fullDate": "EEEE, d. MMMM y",
                       "longDate": "d. MMMM y",
                       "mediumDate": "dd.MM.yyyy",
                       "shortDate": "dd.MM.yy",
                       "mediumTime": "HH:mm:ss",
                       "shortTime": "HH:mm",
                       "timeSeparator": ":",
                       "dateSeparator": ".",
                       "decimalPoint": ",",
                       "groupSeparator": "."
                   }
               },
               //strings
               "monday": [null, "montag"],
               "tuesday": [null, "dienstag"],
               "wednesday": [null, "mittwoch"],
               "thursday": [null, "donnerstag"],
               "friday": [null, "freitag"],
               "saturday": [null, "samstag"],
               "sunday": [null, "sonntag"],
               "january": [null, "januar"],
               "february": [null, "februar"],
               "march": [null, "märz"],
               "april": [null, "april"],
               "may": [null, "mai"],
               "june": [null, "juni"],
               "july": [null, "juli"],
               "august": [null, "august"],
               "september": [null, "september"],
               "october": [null, "oktober"],
               "november": [null, "november"],
               "december": [null, "dezember"]
           },
           "pt": {
               "": { //some metadata
                   "domain": "messages",
                   "lang": "de",
                   "plural_forms": "nplurals=3; plural=n==0 ? 2 : n==1 ? 0 : n<5 ? 1 : 2;",
                   "datetime_formats": {
                       "month": ["janeiro", "fevereiro", "março", "abril", "maio", "junho", "julho", "agosto", "setembro", "outubro", "novembro", "dezembro"],
                       "shortmonth": ["jan", "fev", "mar", "abr", "mai", "jun", "jul", "ago", "set", "out", "nov", "dez"],
                       "day": ["domingo", "segunda", "terça", "quarta", "quinta", "sexta", "sabado"],
                       "shortday": ["dom", "seg", "ter", "qua", "qui", "sex", "sĂˇb"],
                       "ampms": ["AM", "PM"],
                       "medium": "dd/MM/yyyy HH:mm:ss",
                       "short": "dd/MM/yy HH:mm",
                       "fullDate": "EEEE, d 'de' MMMM 'de' y",
                       "longDate": "d 'de' MMMM 'de' y",
                       "mediumDate": "dd/MM/yyyy",
                       "shortDate": "dd/MM/yy",
                       "mediumTime": "HH:mm:ss",
                       "shortTime": "HH:mm",
                       "timeSeparator": ".",
                       "dateSeparator": "/",
                       "decimalPoint": ",",
                       "groupSeparator": " "
                   }
               },
               //strings
               "monday": [null, "segunda"],
               "tuesday": [null, "terça"],
               "wednesday": [null, "quarta"],
               "thursday": [null, "quinta"],
               "friday": [null, "sexta"],
               "saturday": [null, "sabado"],
               "sunday": [null, "domingo"],
               "january": [null, "janeiro"],
               "february": [null, "fevereiro"],
               "march": [null, "março"],
               "april": [null, "abril"],
               "may": [null, "maio"],
               "june": [null, "junho"],
               "july": [null, "julho"],
               "august": [null, "agosto"],
               "september": [null, "septembro"],
               "october": [null, "outubro"],
               "november": [null, "novembro"],
               "december": [null, "dezembro"]
           }

       };

       return out;
   })
